/* $NetBSD$ */

/*
 * System call argument lists.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from	NetBSD: syscalls.master,v 1.8 2009/01/13 22:27:43 pooka Exp
 */

#ifndef _MACH_FASTTRAPS_SYS_SYSCALLARGS_H_
#define	_MACH_FASTTRAPS_SYS_SYSCALLARGS_H_

#define	MACH_FASTTRAPS_SYS_MAXSYSARGS	8

#undef	syscallarg
#define	syscallarg(x)							\
	union {								\
		register_t pad;						\
		struct { x datum; } le;					\
		struct { /* LINTED zero array dimension */		\
			int8_t pad[  /* CONSTCOND */			\
				(sizeof (register_t) < sizeof (x))	\
				? 0					\
				: sizeof (register_t) - sizeof (x)];	\
			x datum;					\
		} be;							\
	}

#undef check_syscall_args
#define check_syscall_args(call) \
	typedef char call##_check_args[sizeof (struct call##_args) \
		<= MACH_FASTTRAPS_SYS_MAXSYSARGS * sizeof (register_t) ? 1 : -1];

struct mach_sys_cthread_set_self_args {
	syscallarg(mach_cproc_t) p;
};
check_syscall_args(mach_sys_cthread_set_self)

/*
 * System call prototypes.
 */

int	mach_sys_cthread_set_self(struct lwp *, const struct mach_sys_cthread_set_self_args *, register_t *);

int	mach_sys_cthread_self(struct lwp *, const void *, register_t *);

int	mach_sys_processor_facilities_used(struct lwp *, const void *, register_t *);

int	mach_sys_load_msr(struct lwp *, const void *, register_t *);

#endif /* _MACH_FASTTRAPS_SYS_SYSCALLARGS_H_ */
